program main;
const 	offset_PE=$3c;
	PE32=$10b;
	PE32plus=$20b;
	offset_idata=104+$18;
	offset_idata_plus=120+$18;
	offset_edata=96+$18;
	offset_edata_plus=112+$18;
	offset_delay=200+$18;
	offset_delay_plus=216+$18;
	offset_NumberRVA=92+$18;
	offset_NumberRVA_plus=108+$18;
	maxentradas=1000;
type Section_Header=record
		Name:string[8];
		VirtualSize:longword;
		VirtualAddress:longword;
		SizeOfRawData:longword;
		PointerToRawData:longword;
		PointerToRelocations:longword;
		PointerToLinenumbers:longword;
		NumberofRelocations:word;
		NumberOfLinenumbers:word;
		Characteristics:longword;
	end;
	Image_data_directory=record
		VirtualAddress,Size:longword;
		end;
	idirectory=record
		Import_Lookup_Table_RVA:longword;
		Time_Date_stamp:Longword;
		Forwarder_Chain:longword;
		Name_RVA:longword;
		Import_Address_Table_RVA:Longword;
		end;

	edirectory=record
		Characteristics:longword;
		TimeDateStamp:longword;
		MajorVersion:word;
		MinorVersion:word;
		Name:longword;
		Base:longword;
		NumberOfFunctions:longword;
		NumberOfNames:longword;
		AddressOfFunctions:longword;
		AddressOfNames:longword;
		AddressOfOrdinals:longword;
		end;
	idelay=record
		grAttrs:longword;
		szName:longword;
		phmod:longword;
		pIAT:longword;
		pINT:longword;
		pBoundIAT:longword;
		pUnloadIAT:longword;
		dwTimeStamp:longword;
		end;
	dllfunc=record
		Index:word;
		Name:string;
		end;
	virtualaddress=record
		posmem, RVA_to_file, size:longword;
		end;	
var 	filename,cadena,show_dll,function_name:string;
	fichero:file of byte;
	file_header:record
		Machine:word;
		NumberOfSections:word;
		Time:longword;
		PointerToSymbolTable:longword;
		NumberOfSymbols:longword;
		SizeOfOptionalHeader:word;
		Characteristics:word;
		end;
	optional_header:record
		Magic:word;
		NumberOfRvaAndSizes:word;
		SizeOfCode:longword;
		AddressOfEntryPoint:longword;
		idata:Image_data_directory;
		edata:Image_data_directory;
		IAT:Image_data_directory;
		delay:Image_data_directory;
		end;
	ent_idirectory:idirectory;
	header_delay:idelay;
	header_edirectory:edirectory;
	pos_PE, pos_section_table, Lookupreg, ptr_function, ptr_name:Longword;
	section_headers:array [0..maxentradas] of virtualaddress;
	seccion:Section_Header;
	cont:byte;
	ordinal:word;
	contdw:longword;
	error_param, debug, imported, delayed, exported, only_dlls, only_funcs, show_ordinal, show_forwarded, not_forwarded:boolean;
function cif_dec_hex(num:byte):char;
 var temp:char;
 begin
 case num of
    0:temp:='0';
    1:temp:='1';
    2:temp:='2';
    3:temp:='3';
    4:temp:='4';
    5:temp:='5';
    6:temp:='6';
    7:temp:='7';
    8:temp:='8';
    9:temp:='9';
    10:temp:='A';
    11:temp:='B';
    12:temp:='C';
    13:temp:='D';
    14:temp:='E';
    15:temp:='F';
    end;
 cif_dec_hex:=temp;
 end;

function byte_dec_hex(num:byte):string;
 var 	temp:string;
 begin
 temp:=cif_dec_hex(num div $10)+cif_dec_hex(num mod $10);
 byte_dec_hex:=temp;
 end;

function word_dec_hex(num:word):string;
 var 	temp:string;
 begin
 temp:=byte_dec_hex(num div $100)+byte_dec_hex(num mod $100);
 word_dec_hex:=temp;
 end;

function longword_dec_hex(num:longword):string;
 var 	temp:string;
 begin
 temp:=word_dec_hex(num div $10000)+word_dec_hex(num mod $10000);
 longword_dec_hex:=temp;
 end;


function read_word (var fich:file of byte; pos:longword):word;
 var 	temp1,temp2:byte;
	temp:word;
 begin
  seek (fich,pos);
  read(fich,temp1);
  read(fich,temp2);
  temp:=temp2*$100+temp1;
  read_word:=temp;
 end;

function read_longword (var fich:file of byte; pos:longword):longword;
 var 	temp1,temp2,temp3,temp4:byte;
	temp:longword;
 begin
  seek (fich,pos);
  read(fich,temp1);
  read(fich,temp2);
  read(fich,temp3);
  read(fich,temp4);
  temp:=temp1+temp2*$100+temp3*$10000+temp4*$1000000;
  read_longword:=temp;
 end;

function read_Section_Header (var fich:file of byte; pos:longword):Section_Header;
 Var 	temp:Section_header;
	cont, temp1:byte;
 begin
  seek(fich,pos);
  temp.Name[0]:=chr(8);
  for cont:=1 to 8 do begin
	read(fich,temp1);
	temp.Name[cont]:=char(temp1);
	end;
  temp.VirtualSize:=read_longword(fich,pos+8);
  temp.VirtualAddress:=read_longword(fich,pos+12);
  temp.SizeOfRawData:=read_longword(fich,pos+16);
  temp.PointerToRawData:=read_longword(fich,pos+20);
  temp.PointerToRelocations:=read_longword(fich,pos+24);
  temp.PointerToLinenumbers:=read_longword(fich,pos+28);
  temp.NumberofRelocations:=read_word(fich,pos+32);
  temp.NumberOfLinenumbers:=read_word(fich,pos+34);
  temp.Characteristics:=read_longword(fich,pos+36);
  read_Section_Header:=temp;
 end;

function read_edirectory (var fich:file of byte; pos:longword):edirectory;
 Var 	temp:edirectory;
 begin
  temp.Characteristics:=read_longword(fich,pos);
  temp.TimeDateStamp:=read_longword(fich,pos+4);
  temp.MajorVersion:=read_word(fich,pos+8);
  temp.MinorVersion:=read_word(fich,pos+10);
  temp.Name:=read_longword(fich,pos+12);
  temp.Base:=read_longword(fich,pos+16);
  temp.NumberOfFunctions:=read_word(fich,pos+20);
  temp.NumberOfNames:=read_word(fich,pos+24);
  temp.AddressOfFunctions:=read_longword(fich,pos+28);
  temp.AddressOfNames:=read_longword(fich,pos+32);
  temp.AddressOfOrdinals:=read_longword(fich,pos+36);
  read_edirectory:=temp;
 end;

Function read_idirectory(var fich:file of byte; pos:longword):idirectory;
 var	temp:idirectory;
 begin
  temp.Import_Lookup_Table_RVA:=read_longword(fich,pos);
  temp.Time_Date_Stamp:=read_longword(fich,pos+4);
  temp.Forwarder_Chain:=read_longword(fich,pos+8);
  temp.Name_RVA:=read_longword(fich,pos+12);
  temp.Import_Address_Table_RVA:=read_longword(fich,pos+16);
  read_idirectory:=temp;
 end;

Function read_Image_data_directory(var fich:file of byte; pos:longword; name:string):Image_data_directory;
 Var temp:Image_data_directory;
 begin
  temp.VirtualAddress:=read_longword(fich,pos);
  temp.Size:=read_longword(fich,pos+4);
  if debug then Writeln('pos_'+name+' = $'+longword_dec_hex(temp.VirtualAddress));
  if debug then Writeln('Size_'+name+' = $'+longword_dec_hex(temp.Size));
  read_Image_data_directory:=temp;
 end;

Function is_idirectory_null(ent_dir:idirectory):boolean;
 var temp:boolean;
 begin
  temp:=false;
  if (ent_idirectory.Import_Lookup_Table_RVA=0) and 
	(ent_idirectory.Time_Date_Stamp=0) and 
	(ent_idirectory.Forwarder_Chain=0) and
	(ent_idirectory.Name_RVA=0) and
	(ent_idirectory.Import_Address_Table_RVA=0) then temp:=true;
  is_idirectory_null:=temp;
 end;

Function read_string(var fich:file of byte; pos:longword):string;
 Var temp:string; 
     car:byte;
 begin
  temp:='';
  seek(fich,pos);
  read(fich,car);
  repeat begin
    temp:=temp+char(car);
    read(fich,car);
    end;
  until car=0;
  read_string:=temp;
 end;

Function read_dllfunc (var fich:file of byte; pos:longword):dllfunc;
 Var 	temp:dllfunc; 
	temp1,temp2:byte;
 begin
  seek(fich,pos);
  temp.Name:='';
  read(fich,temp1);
  read(fich,temp2);
  temp.Index:=temp2*$100+temp1;
  repeat begin
    read(fich,temp1);
    temp.Name:=temp.Name+chr(temp1);
    end;
  until temp1=0;
  read_dllfunc:=temp;
 end;

Function RVA_to_file(direccion:longword):longword;
 Var temp:longword; 
     cont:word;
     encontrado:boolean;
 begin
  cont:=0;
  encontrado:=false;
  while (not(encontrado) and (cont<file_header.NumberOfSections)) do begin
    if (section_headers[cont].posmem<=direccion) and 
	(section_headers[cont].posmem+section_headers[cont].size>=direccion) then begin
	temp:=direccion-section_headers[cont].posmem+section_headers[cont].RVA_to_file;
	encontrado:=true;
	end;
    inc(cont);
    end;
  RVA_to_file:=temp;
 end;

Function is_delay_null(header:idelay):boolean;
 Var temp:boolean;
 begin
  temp:=false;
  with header do
  if (grAttrs=0) and (szName=0) and (phmod=0) and (pIAT=0) and (pINT=0) and (pBoundIAT=0) and (pUnloadIAT=0) and (dwTimeStamp=0)
	then temp:=true;
  is_delay_null:=temp;
 end;

Function read_delay(var fich:file of byte; pos:longword):idelay;
 var temp:idelay;
 begin
	temp.grAttrs:=read_longword(fichero,pos);
	temp.szName:=read_longword(fichero,pos+4);
	temp.phmod:=read_longword(fichero,pos+8);
	temp.pIAT:=read_longword(fichero,pos+12);
	temp.pINT:=read_longword(fichero,pos+16);
	temp.pBoundIAT:=read_longword(fichero,pos+20);
	temp.pUnloadIAT:=read_longword(fichero,pos+24);
	temp.dwTimeStamp:=read_longword(fichero,pos+28);
 read_delay:=temp;
 end;

Procedure print_section_header(section:Section_Header);
 Var	temp:string;
 begin
  Writeln('*****************************');
  Writeln('Name:                '+section.Name);
  temp:=longword_dec_hex(section.VirtualSize);
  Writeln('VirtualSize          '+temp);
  temp:=longword_dec_hex(section.VirtualAddress);
  Writeln('VirtualAddress       '+temp);
  temp:=longword_dec_hex(section.SizeOfRawData);
  Writeln('SizeOfRawData        '+temp);
  temp:=longword_dec_hex(section.PointerToRawData);
  Writeln('PointerToRawData     '+temp);
  temp:=longword_dec_hex(section.PointerToRelocations);
  Writeln('PointerToRelocations '+temp);
  temp:=longword_dec_hex(section.PointerToLinenumbers);
  Writeln('PointerToLinenumbers '+temp);
  temp:=longword_dec_hex(section.NumberOfRelocations);
  Writeln('NumberOfRelocations  '+temp);
  Writeln('*****************************');
 end;

Procedure print_dllfuncs(var fich:file of byte; pos:longword; dll:string; hide_dll,show_num:boolean);
 Var	contador, registro:longword;
	temp:dllfunc;
 begin
  contador:=pos;
  registro:=read_longword(fichero,contador);
  while (registro<>0) do begin
    if not(hide_dll) then write(dll+ ' ');
    if registro >=$80000000 then begin
		temp.Index:=registro-$80000000;
		str(temp.Index,temp.Name)
		end
        else temp:=read_dllfunc(fich, RVA_to_file(registro));
    if show_num then begin
	Write(temp.Index);
	Write(' ');
	end;
    Writeln(temp.Name);
    contador:=contador+4;
    registro:=read_longword(fichero,contador);
    end;
 end;

Procedure print_exportdllfuncs(var fich:file of byte; pos:longword; numreg:longword);
 Var	contador:longword;
	registro:longword;
 begin

  for contador:=0 to numreg-1 do begin
	registro:=read_longword(fichero,contador*8+pos);
	write(longword_dec_hex(registro));
	write(' ');
	if (registro<optional_header.edata.VirtualAddress) or
	   (registro>optional_header.edata.VirtualAddress+optional_header.edata.Size) then
	Writeln ('Función proveída por el archivo')
	else writeln(read_string(fich,RVA_to_file(registro)));
	{Writeln(longword_dec_hex(RVA_to_file(registro.forwarder)));}
	{Writeln(read_string(fich, RVA_to_file(registro.Forwarder)));}
	end;
 end;

Procedure print_mod_dllfuncs(var fich:file of byte; pos:longword; numreg:longword; nums:boolean);
 Var	contador, registro:longword;
 begin
  for contador:=0 to numreg-1 do begin
	registro:=read_longword(fich,pos+contador*4);
	writeln(read_string(fichero,RVA_to_file(registro)));
	{Writeln(longword_dec_hex(RVA_to_file(registro.forwarder)));}
	{Writeln(read_string(fich, RVA_to_file(registro.Forwarder)));}
	end;
 end;

procedure init(param:byte);
 var temp:boolean;
 begin
  temp:=false;
  if (Paramstr(param)='-d') or (Paramstr(param)='--debug') then begin 
	debug:=true;
	temp:=true;
	end;
  if (Paramstr(param)='-i') or (Paramstr(param)='--imported') then begin
	imported:=true;
	delayed:=true;
	temp:=true;
	end;
  if (Paramstr(param)='-od') or (Paramstr(param)='--only-delay-loaded') then begin
	imported:=false;
	delayed:=true;
	temp:=true;
	end;
  if (Paramstr(param)='-nd') or (Paramstr(param)='--not-delay-loaded') then begin
	imported:=true;
	delayed:=false;
	temp:=true;
	end;
  if (Paramstr(param)='-e') or (Paramstr(param)='--exported') then begin
	exported:=true;
	temp:=true;
	end;
  if (Paramstr(param)='-f') or (Paramstr(param)='--forwarded') then begin
	show_forwarded:=true;
	not_forwarded:=true;
	temp:=true;
	end;
  if (Paramstr(param)='-of') or (Paramstr(param)='--only-forwarded') then begin
	show_forwarded:=true;
	not_forwarded:=false;
	temp:=true;
	end;
  if (Paramstr(param)='-nf') or (Paramstr(param)='--only-not-forwarded') then begin
	show_forwarded:=false;
	not_forwarded:=true;
	temp:=true;
	end;
  if (Paramstr(param)='-o') or (Paramstr(param)='--ordinal') then begin
	show_ordinal:=true;
	temp:=true;
	end;
  if (Paramstr(param)='-l') or (Paramstr(param)='--only-dlls') then begin
	only_dlls:=true;
	temp:=true;
	end;
  if (Paramstr(param)='-u') or (Paramstr(param)='--only-funcs') then begin
	only_funcs:=true;
	temp:=true;
	end;
  if copy(Paramstr(param),1,5)='-dll=' then begin
	show_dll:=copy(Paramstr(param),6,length(Paramstr(param)));
	temp:=true;
	end;
  if show_dll<>'' then  only_funcs:=true;
  if not(temp) then begin
	Writeln ('Unknown option: '+Paramstr(param));
	error_param:=true;
	end;
 end;


begin
{Init Params}
debug:=false;
imported:=false;
exported:=false;
only_dlls:=false;
only_funcs:=false;
show_ordinal:=false;
show_forwarded:=false;
not_forwarded:=true;
error_param:=false;
delayed:=false;
show_dll:='';
filename:=Paramstr(1);
for cont:=2 to Paramcount do init(cont);
if error_param then begin
	Writeln('Usage: extdll <file> <options>');
	Writeln('');
	Writeln('General Options:');
	Writeln('-d	--debug		Show imported dll functions');
	Writeln('-i	--imported	Show imported dll functions');
	Writeln('-e	--exported	Show exported dll functions');
	Writeln('-o	--ordinal	Show ordinal numbers from functions');
	Writeln('');
	Writeln('Imported Mode Options:');
	Writeln('-dll=<filename>		Show only functions imported from <filename>');
	Writeln('-l	--only-dlls	Show only the names of dll files imported');
	Writeln('-u	--only-funcs	Show only the names of dll functions imported');
	Writeln('-od	--only-delay-loaded	Show only the names of dll functions not delay loaded');
	Writeln('-nd	--not-delay-loaded	Show only the names of dll functions delay loaded');
	Writeln('');
	Writeln('Exported Mode Options:');
	Writeln('-f	--forwarded	Add forwarded function to exported function');
	Writeln('-of	--only-forwarded	Show only functions which are forwarded to other modules');
	Writeln('-nf	--only-not-forwarded	Show only functions which are not forwarded to other modules');
	Writeln('');
	exit;
	end;

{Obtención de valores del fichero}
assign (fichero,filename);
reset(fichero);
  {Pre PE}
  pos_PE:=read_word(fichero,offset_PE);
  if debug then Writeln('El Offset hasta el inicio de PE es $'+word_dec_hex(pos_PE));
  {File Header}
  file_header.NumberofSections:=read_word(fichero,pos_PE+$6);
  if debug then Writeln('NumberofSections = $'+word_dec_hex(file_header.NumberofSections));
  {Optional Header}
  optional_header.Magic:= read_word(fichero,pos_PE+$18);
  if debug then Writeln('Magic = $'+word_dec_hex(optional_header.Magic));
  case optional_header.Magic of
	PE32:begin
		if debug then writeln('El fichero es de tipo PE32');
		optional_header.NumberOfRvaAndSizes:=read_word(fichero,pos_PE+offset_NumberRVA);
		if debug then Writeln('NumberOfRvaAndSize = $'+longword_dec_hex(optional_header.NumberOfRvaAndSizes));
		if optional_header.NumberOfRVAAndSizes>=$1 then 
			optional_header.idata:=read_Image_data_directory(fichero,pos_PE+offset_idata,'idata');
		if optional_header.NumberOfRVAAndSizes>=$2 then 
			optional_header.edata:=read_Image_data_directory(fichero,pos_PE+offset_edata,'edata');
		if optional_header.NumberOfRVAAndSizes>=$D then 
			optional_header.delay:=read_Image_data_directory(fichero,pos_PE+offset_delay,'delay');
		pos_section_table:=pos_PE+offset_NumberRVA+4+8*optional_header.NumberOfRvaAndSizes;
		end;
	PE32plus:begin
		if debug then writeln('El fichero es d1e tipo PE32+');
		optional_header.NumberOfRvaAndSizes:=read_word(fichero,pos_PE+offset_NumberRVA_plus);
		if debug then Writeln('NumberOfRvaAndSize = $'+longword_dec_hex(optional_header.NumberOfRvaAndSizes));
		if optional_header.NumberOfRVAAndSizes>=$1 then 
			optional_header.idata:=read_Image_data_directory(fichero,pos_PE+offset_idata,'idata');
		if optional_header.NumberOfRVAAndSizes>=$2 then 
			optional_header.edata:=read_Image_data_directory(fichero,pos_PE+offset_edata,'edata');
		if optional_header.NumberOfRVAAndSizes>=$D then 
			optional_header.delay:=read_Image_data_directory(fichero,pos_PE+offset_delay,'delay');
		pos_section_table:=pos_PE+offset_NumberRVA_plus+4+8*optional_header.NumberOfRvaAndSizes;
		end;
	else begin
		Writeln('Error: El fichero no es PE32 ni PE32+');
		exit;
		end;
	end;

  {Section Headers}
  for cont:=0 to file_header.NumberOfSections-1 do begin
    seccion:=read_Section_Header(fichero,pos_section_table+ cont*40);
    if debug then print_Section_Header(seccion);
    section_headers[cont].posmem:=seccion.VirtualAddress;
    section_headers[cont].size:=seccion.SizeOfRawData;
    section_headers[cont].RVA_to_file:=seccion.PointerToRawData;
    end;

{Muestra idata}
{Import Table}
if (optional_header.idata.Size>$00000000) and imported then begin
 Lookupreg:=optional_header.idata.VirtualAddress;
 ent_idirectory:=read_idirectory(fichero,RVA_to_file(Lookupreg));
 while not(is_idirectory_null(ent_idirectory)) do begin
   cadena:=read_string(fichero,RVA_to_file(ent_idirectory.Name_RVA));
   if ent_idirectory.Import_Lookup_Table_RVA=$00000000
	then ent_idirectory.Import_Lookup_Table_RVA:=ent_idirectory.Import_Address_Table_RVA;
   if only_dlls and (show_dll='') then Writeln(cadena);
   if not(only_dlls) and (show_dll='') then 
	print_dllfuncs(fichero, RVA_to_file(ent_idirectory.Import_Lookup_Table_RVA), cadena, only_funcs,show_ordinal);
   if show_dll=cadena then print_dllfuncs(fichero, RVA_to_file(ent_idirectory.Import_Lookup_Table_RVA), cadena, not(only_funcs),show_ordinal);
   Lookupreg:=Lookupreg+20;
   ent_idirectory:=read_idirectory(fichero,RVA_to_file(Lookupreg));
   end;
 end;
{Delay Load}
if (optional_header.delay.Size>$00000000) and delayed then begin
 Lookupreg:=optional_header.delay.VirtualAddress;
 header_delay:=read_delay(fichero,RVA_to_File(Lookupreg));
 while not(is_delay_null(header_delay)) do begin
   cadena:=read_string(fichero,RVA_to_file(header_delay.szName));
   if only_dlls and (show_dll='') then Writeln(cadena);
   if not(only_dlls) and (show_dll='') then 
	print_dllfuncs(fichero, RVA_to_file(header_delay.pINT), cadena, only_funcs,show_ordinal);
   if (show_dll=cadena) then print_dllfuncs(fichero, RVA_to_file(header_delay.pINT), cadena, not(only_funcs),show_ordinal);
   Lookupreg:=Lookupreg+$20;
   header_delay:=read_delay(fichero,RVA_to_File(Lookupreg));
   end;
 end;
if imported and (optional_header.idata.Size=$00000000) and (optional_header.delay.Size=$00000000) then
	Writeln('No existe ningún DLL del que se importen funciones.');

{Muestra edata}
if (optional_header.edata.Size>$00000000) and exported then begin
	header_edirectory:=read_edirectory(fichero,RVA_to_file(optional_header.edata.VirtualAddress));
	for contdw:=0 to header_edirectory.NumberOfFunctions-1 do begin
		ptr_name:=read_longword(fichero,RVA_to_file(header_edirectory.AddressOfNames)+contdw*4);
		if contdw<header_edirectory.NumberOfNames then function_name:=read_string(fichero,RVA_to_file(ptr_name))
			else function_name:='Not available';
		ordinal:=read_word(fichero,RVA_to_file(header_edirectory.AddressOfOrdinals)+contdw*2);
		ptr_function:=read_longword(fichero,RVA_to_file(header_edirectory.AddressOfFunctions)+(ordinal+1-header_edirectory.base)*4);
		if (ptr_function>=optional_header.edata.VirtualAddress) and
		  (ptr_function<=optional_header.edata.VirtualAddress+optional_header.edata.Size) and show_forwarded then begin
			if show_ordinal then begin
				write(ordinal);
				write(' ');
				end;
			write(function_name);
			write('	-->	');
			write(read_string(fichero,RVA_to_file(ptr_function)));
			writeln();
			end
		else if not_forwarded then begin
			if show_ordinal then begin
				write(ordinal);
				write(' ');
				end;
			write(function_name);
			writeln();
			end;
		end;
	end;
if exported and (optional_header.edata.Size=$00000000) then
	Writeln('El fichero no exporta ninguna función');
close(fichero);
end.
